

#include <srgp.h>
#include <math.h>
#include "descartes.h"


int Sqr(int n)
{
   return n*n;
}


point_t GetPoint(void)
{
   point_t p;
   locator_measure lm;

   SRGP_waitEvent(INDEFINITE);
   SRGP_getLocator(&lm); 
   while ((lm.button_chord[LEFT_BUTTON] == UP) && (lm.button_chord[MIDDLE_BUTTON] == UP)) {
      SRGP_waitEvent(INDEFINITE);
      SRGP_getLocator(&lm);
   }
   if (lm.button_chord[LEFT_BUTTON] == DOWN) {
      p.x = lm.position.x;
      p.y = lm.position.y;
      SRGP_markerCoord(p.x, p.y); 
      SRGP_beep();
   } else {   
      p.x = -1;
      p.y = -1;
   }
   return p;
}


point_t Point(int a, int b)
{
   point_t p;

   p.x = a;
   p.y = b;
   return p;
}


int XCoord(point_t p)
{
   return p.x;
}


int YCoord(point_t p)
{
   return p.y;
}


lineSeg_t LineSeg(point_t p1, point_t p2)
{
   lineSeg_t l;
   
   l.initial = p1;
   l.final = p2;
   return l;
}


point_t InitialPoint(lineSeg_t l)
{
   return l.initial;
}


point_t FinalPoint(lineSeg_t l)
{
   return l.final;
}


float Length(lineSeg_t l)
{
   return sqrt(Sqr(XCoord(InitialPoint(l)) - XCoord(FinalPoint(l)))
             + Sqr(YCoord(InitialPoint(l)) - YCoord(FinalPoint(l))));
}


void DrawLineSeg(lineSeg_t l) 
{
   SRGP_lineCoord(XCoord(InitialPoint(l)),
                  YCoord(InitialPoint(l)),
                  XCoord(FinalPoint(l)),
                  YCoord(FinalPoint(l))
                 );
}

void OpenGraphics(void)
{
   SRGP_begin("CP1h Graphics", 500, 500, 1, 0);
   SRGP_enableSynchronous(); 
   SRGP_setInputMode(LOCATOR, EVENT);
   SRGP_setLocatorButtonMask(LEFT_BUTTON_MASK | MIDDLE_BUTTON_MASK);
}

void CloseGraphics(void)
{
   locator_measure lm;

   printf("Press right mouse button to exit!\n");
   SRGP_beep();
   SRGP_waitEvent(INDEFINITE);
   SRGP_getLocator(&lm);   
   SRGP_setLocatorButtonMask(RIGHT_BUTTON_MASK);
   while (lm.button_chord[RIGHT_BUTTON] == UP) {
      SRGP_waitEvent(INDEFINITE);
      SRGP_getLocator(&lm);
   }
   SRGP_end();
}

